package server

import (
	cs "git.loafle.net/commons/server-go"
	ogrs "git.loafle.net/overflow/gateway_rpc/server"
	"git.loafle.net/overflow/member_gateway_rpc/subscribe"
)

type ServerHandler interface {
	ogrs.ServerHandler
}

type ServerHandlers struct {
	ogrs.ServerHandlers
}

func (sh *ServerHandlers) Init(serverCtx cs.ServerCtx) error {
	if err := sh.ServerHandlers.Init(serverCtx); nil != err {
		return err
	}

	subscribe.InitPackage()

	return nil
}

func (sh *ServerHandlers) OnStart(serverCtx cs.ServerCtx) error {
	if err := sh.ServerHandlers.OnStart(serverCtx); nil != err {
		return err
	}

	subscribe.StartPackage()

	return nil
}

func (sh *ServerHandlers) OnStop(serverCtx cs.ServerCtx) {
	subscribe.StopPackage()

	sh.ServerHandlers.OnStop(serverCtx)
}

func (sh *ServerHandlers) Destroy(serverCtx cs.ServerCtx) {
	subscribe.DestroyPackage()

	sh.ServerHandlers.Destroy(serverCtx)
}
